/*
	   	I	A	B
     Personal Source Code

  Features: Send Text, Get Text, Lock Microphone, Free Microphone.

  Type: Dynamic Link Library for mIRC 6.12 and above.

  */
#include <iostream>
#include <windows.h>

#define pub_func(procname) int __stdcall procname(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)

// string_gettoken by [TACO]
int string_numtok(char *data, char ch){
	int counter = 0;
	int size = 0;
	int tokens = 0;
	size = strlen(data);
	while (counter < size){
		if (data[counter] == ch)
			tokens++;
			counter++;
	}
	return tokens + 1;
}


char *string_gettoken(char *data, int num, char ch){
	int counter = 0;
	int tok_count = 0;
	int pos = 0;
	int size = strlen(data);
	int tokens = string_numtok(data,ch);
	static char *token = NULL;
	if (tokens < num)
		return NULL;
	token = (char*)malloc(sizeof(char) * size);
	memset(token,0,size);
	while (counter < size){
	if ((tok_count == num) && (data[counter] != ch)){
	token[pos] = data[counter];
	pos++;
	}
	if (data[counter] == ch){
			tok_count++;
	}            
			counter++;
	}
		return token;
}

pub_func(gettext) {
	 HWND mywindowclass = FindWindow("DlgGroupChat Window Class", NULL);
     HWND wtlsplitterwindow = FindWindowEx(mywindowclass, 0, "wtl_splitterwindow", NULL);
     wtlsplitterwindow = FindWindowEx(wtlsplitterwindow, 0, "wtl_splitterwindow", NULL);
     wtlsplitterwindow = FindWindowEx(wtlsplitterwindow, 0, "wtl_splitterwindow", NULL);
     wtlsplitterwindow = FindWindowEx(wtlsplitterwindow, 0, "wtl_splitterwindow", NULL);
     HWND atlfe = GetWindow(wtlsplitterwindow, GW_CHILD);
     HWND atlaxwin = FindWindowEx(atlfe, 0, "atlaxwin71", NULL);
     atlaxwin = FindWindowEx(atlfe, atlaxwin, "atlaxwin71", NULL);
     HWND x = FindWindowEx(atlaxwin, 0, "#32770", NULL);
     HWND richedita = FindWindowEx(x, 0, "richedit20a", NULL);

	 // Error Checking:
	 if (!mywindowclass)  { sprintf(data, "E_WINDOW_NOT_FOUND"); }
	 if (!wtlsplitterwindow)  { sprintf(data, "E_WINDOW_NOT_FOUND"); }
	 if (!atlfe)  { sprintf(data, "E_UNABLE_TO_FIND_PARENT"); }
	 if (!richedita)  { sprintf(data, "E_RICHEDIT_NOT_FOUND"); }


    long lngCount = SendMessage(richedita, EM_GETLINECOUNT, 0, 0);
    long lngLength = SendMessage(richedita, EM_LINELENGTH, lngCount-2, 0);
	TCHAR strBuffer[1024]; *(WORD *) strBuffer = 1024;    
	LRESULT bla = SendMessage(richedita, EM_GETLINE, lngCount-2, (LPARAM)(LPCSTR)strBuffer);
	sprintf(data,"%s",strBuffer);

	return 3;
}

pub_func(sendtext) {

	HWND parent = FindWindow("DlgGroupChat Window Class", NULL);
	HWND child = FindWindowEx(parent, 0, "WTL_SplitterWindow", NULL);
	child = FindWindowEx(child, 0, "WTL_SplitterWindow", NULL);
	child = FindWindowEx(child, 0, "WTL_SplitterWindow", NULL);
	child = FindWindowEx(child, 0, "WTL_SplitterWindow", NULL);
	HWND alt = GetWindow(child, GW_CHILD);
	alt = FindWindowEx(alt, 0, "AtlAxWin71", NULL);
	alt = FindWindowEx(alt, 0, "#32770", NULL);
	HWND rich20 = FindWindowEx(alt, 0, "RichEdit20A", NULL);
	rich20 = FindWindowEx(alt, rich20, "RichEdit20A", NULL);
	
	if (!parent)  { sprintf(data, "E_WINDOW_NOT_FOUND"); }
	if (!rich20)  { sprintf(data, "E_RICHEDIT_NOT_FOUND"); }

	 //TCHAR buf[3096] = string_gettoken(data, 0, ';');
	// SendMessage(Results, WM_SETTEXT, strlen(buf), (LPARAM)(LPCSTR)buf);
	SendMessage(rich20, WM_SETTEXT, strlen(string_gettoken(data,0,';')), (LRESULT)(LPCSTR)string_gettoken(data,0,';'));
	SendMessage(rich20, WM_KEYDOWN, 13, 0);
	sprintf(data,"S_OK");
	return 3;
}

pub_func(lockmic) {
	HWND dlggroupchatwindowclass = FindWindow("dlggroupchat window class", NULL);
	 if (!dlggroupchatwindowclass)  { sprintf(data, "E_WINDOW_NOT_FOUND"); }
   PostMessage(dlggroupchatwindowclass, WM_COMMAND, 33340, 0);
   return 3;
}

pub_func(freemic) {
	HWND dlggroupchatwindowclass = FindWindow("dlggroupchat window class", NULL);
	if (!dlggroupchatwindowclass)  { sprintf(data, "E_WINDOW_NOT_FOUND"); }
   PostMessage(dlggroupchatwindowclass, WM_COMMAND, 33343, 0);
   return 3;
}

// For Testing Purpose you may send any Command Value (if it exists it will be accepted)
pub_func(sendcommand) {
	HWND dlggroupchatwindowclass = FindWindow("dlggroupchat window class", NULL);
 if (!dlggroupchatwindowclass)  { sprintf(data, "E_WINDOW_NOT_FOUND"); }
   PostMessage(dlggroupchatwindowclass, WM_COMMAND, atoi(string_gettoken(data,0,';')), 0);
   return 3;
}

pub_func(about) {
	sprintf(data,"Haso Keric 2007");
	return 3;
}